// This file was generated by qtwaylandscanner
// source file is pointer-gestures-unstable-v1.xml

#ifndef QT_WAYLAND_SERVER_POINTER_GESTURES_UNSTABLE_V1
#define QT_WAYLAND_SERVER_POINTER_GESTURES_UNSTABLE_V1

#include "wayland-server-core.h"
#include "wayland-pointer-gestures-unstable-v1-server-protocol.h"
#include <QByteArray>
#include <QMultiMap>
#include <QString>

#include <unistd.h>

#ifndef WAYLAND_VERSION_CHECK
#define WAYLAND_VERSION_CHECK(major, minor, micro) \
    ((WAYLAND_VERSION_MAJOR > (major)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR > (minor)) || \
    (WAYLAND_VERSION_MAJOR == (major) && WAYLAND_VERSION_MINOR == (minor) && WAYLAND_VERSION_MICRO >= (micro)))
#endif

QT_BEGIN_NAMESPACE
QT_WARNING_PUSH
QT_WARNING_DISABLE_GCC("-Wmissing-field-initializers")
QT_WARNING_DISABLE_CLANG("-Wmissing-field-initializers")

namespace QtWaylandServer {
    class  zwp_pointer_gestures_v1
    {
    public:
        zwp_pointer_gestures_v1(struct ::wl_client *client, int id, int version);
        zwp_pointer_gestures_v1(struct ::wl_display *display, int version);
        zwp_pointer_gestures_v1(struct ::wl_resource *resource);
        zwp_pointer_gestures_v1();

        virtual ~zwp_pointer_gestures_v1();

        class Resource
        {
        public:
            Resource() : zwp_pointer_gestures_v1_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            zwp_pointer_gestures_v1 *zwp_pointer_gestures_v1_object;
            zwp_pointer_gestures_v1 *object() { return zwp_pointer_gestures_v1_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, int id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, int id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, int id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobalRemoved() const { return m_globalRemovedEvent; }
        void globalRemove();

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


    protected:
        virtual Resource *zwp_pointer_gestures_v1_allocate();

        virtual void zwp_pointer_gestures_v1_destroy_global();

        virtual void zwp_pointer_gestures_v1_bind_resource(Resource *resource);
        virtual void zwp_pointer_gestures_v1_destroy_resource(Resource *resource);

        virtual void zwp_pointer_gestures_v1_get_swipe_gesture(Resource *resource, uint32_t id, struct ::wl_resource *pointer);
        virtual void zwp_pointer_gestures_v1_get_pinch_gesture(Resource *resource, uint32_t id, struct ::wl_resource *pointer);
        virtual void zwp_pointer_gestures_v1_release(Resource *resource);
        virtual void zwp_pointer_gestures_v1_get_hold_gesture(Resource *resource, uint32_t id, struct ::wl_resource *pointer);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);
        static int deferred_destroy_global_func(void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        static const struct ::zwp_pointer_gestures_v1_interface m_zwp_pointer_gestures_v1_interface;

        static void handle_get_swipe_gesture(
            ::wl_client *client,
            struct wl_resource *resource,
            uint32_t id,
            struct ::wl_resource *pointer);
        static void handle_get_pinch_gesture(
            ::wl_client *client,
            struct wl_resource *resource,
            uint32_t id,
            struct ::wl_resource *pointer);
        static void handle_release(
            ::wl_client *client,
            struct wl_resource *resource);
        static void handle_get_hold_gesture(
            ::wl_client *client,
            struct wl_resource *resource,
            uint32_t id,
            struct ::wl_resource *pointer);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        struct ::wl_display *m_display;
        struct wl_event_source *m_globalRemovedEvent;
        struct DisplayDestroyedListener : ::wl_listener {
            zwp_pointer_gestures_v1 *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };

    class  zwp_pointer_gesture_swipe_v1
    {
    public:
        zwp_pointer_gesture_swipe_v1(struct ::wl_client *client, int id, int version);
        zwp_pointer_gesture_swipe_v1(struct ::wl_display *display, int version);
        zwp_pointer_gesture_swipe_v1(struct ::wl_resource *resource);
        zwp_pointer_gesture_swipe_v1();

        virtual ~zwp_pointer_gesture_swipe_v1();

        class Resource
        {
        public:
            Resource() : zwp_pointer_gesture_swipe_v1_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            zwp_pointer_gesture_swipe_v1 *zwp_pointer_gesture_swipe_v1_object;
            zwp_pointer_gesture_swipe_v1 *object() { return zwp_pointer_gesture_swipe_v1_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, int id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, int id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, int id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobalRemoved() const { return m_globalRemovedEvent; }
        void globalRemove();

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


        void send_begin(uint32_t serial, uint32_t time, struct ::wl_resource *surface, uint32_t fingers);
        void send_begin(struct ::wl_resource *resource, uint32_t serial, uint32_t time, struct ::wl_resource *surface, uint32_t fingers);
        void send_update(uint32_t time, wl_fixed_t dx, wl_fixed_t dy);
        void send_update(struct ::wl_resource *resource, uint32_t time, wl_fixed_t dx, wl_fixed_t dy);
        void send_end(uint32_t serial, uint32_t time, int32_t cancelled);
        void send_end(struct ::wl_resource *resource, uint32_t serial, uint32_t time, int32_t cancelled);

    protected:
        virtual Resource *zwp_pointer_gesture_swipe_v1_allocate();

        virtual void zwp_pointer_gesture_swipe_v1_destroy_global();

        virtual void zwp_pointer_gesture_swipe_v1_bind_resource(Resource *resource);
        virtual void zwp_pointer_gesture_swipe_v1_destroy_resource(Resource *resource);

        virtual void zwp_pointer_gesture_swipe_v1_destroy(Resource *resource);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);
        static int deferred_destroy_global_func(void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        static const struct ::zwp_pointer_gesture_swipe_v1_interface m_zwp_pointer_gesture_swipe_v1_interface;

        static void handle_destroy(
            ::wl_client *client,
            struct wl_resource *resource);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        struct ::wl_display *m_display;
        struct wl_event_source *m_globalRemovedEvent;
        struct DisplayDestroyedListener : ::wl_listener {
            zwp_pointer_gesture_swipe_v1 *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };

    class  zwp_pointer_gesture_pinch_v1
    {
    public:
        zwp_pointer_gesture_pinch_v1(struct ::wl_client *client, int id, int version);
        zwp_pointer_gesture_pinch_v1(struct ::wl_display *display, int version);
        zwp_pointer_gesture_pinch_v1(struct ::wl_resource *resource);
        zwp_pointer_gesture_pinch_v1();

        virtual ~zwp_pointer_gesture_pinch_v1();

        class Resource
        {
        public:
            Resource() : zwp_pointer_gesture_pinch_v1_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            zwp_pointer_gesture_pinch_v1 *zwp_pointer_gesture_pinch_v1_object;
            zwp_pointer_gesture_pinch_v1 *object() { return zwp_pointer_gesture_pinch_v1_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, int id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, int id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, int id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobalRemoved() const { return m_globalRemovedEvent; }
        void globalRemove();

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


        void send_begin(uint32_t serial, uint32_t time, struct ::wl_resource *surface, uint32_t fingers);
        void send_begin(struct ::wl_resource *resource, uint32_t serial, uint32_t time, struct ::wl_resource *surface, uint32_t fingers);
        void send_update(uint32_t time, wl_fixed_t dx, wl_fixed_t dy, wl_fixed_t scale, wl_fixed_t rotation);
        void send_update(struct ::wl_resource *resource, uint32_t time, wl_fixed_t dx, wl_fixed_t dy, wl_fixed_t scale, wl_fixed_t rotation);
        void send_end(uint32_t serial, uint32_t time, int32_t cancelled);
        void send_end(struct ::wl_resource *resource, uint32_t serial, uint32_t time, int32_t cancelled);

    protected:
        virtual Resource *zwp_pointer_gesture_pinch_v1_allocate();

        virtual void zwp_pointer_gesture_pinch_v1_destroy_global();

        virtual void zwp_pointer_gesture_pinch_v1_bind_resource(Resource *resource);
        virtual void zwp_pointer_gesture_pinch_v1_destroy_resource(Resource *resource);

        virtual void zwp_pointer_gesture_pinch_v1_destroy(Resource *resource);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);
        static int deferred_destroy_global_func(void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        static const struct ::zwp_pointer_gesture_pinch_v1_interface m_zwp_pointer_gesture_pinch_v1_interface;

        static void handle_destroy(
            ::wl_client *client,
            struct wl_resource *resource);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        struct ::wl_display *m_display;
        struct wl_event_source *m_globalRemovedEvent;
        struct DisplayDestroyedListener : ::wl_listener {
            zwp_pointer_gesture_pinch_v1 *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };

    class  zwp_pointer_gesture_hold_v1
    {
    public:
        zwp_pointer_gesture_hold_v1(struct ::wl_client *client, int id, int version);
        zwp_pointer_gesture_hold_v1(struct ::wl_display *display, int version);
        zwp_pointer_gesture_hold_v1(struct ::wl_resource *resource);
        zwp_pointer_gesture_hold_v1();

        virtual ~zwp_pointer_gesture_hold_v1();

        class Resource
        {
        public:
            Resource() : zwp_pointer_gesture_hold_v1_object(nullptr), handle(nullptr) {}
            virtual ~Resource() {}

            zwp_pointer_gesture_hold_v1 *zwp_pointer_gesture_hold_v1_object;
            zwp_pointer_gesture_hold_v1 *object() { return zwp_pointer_gesture_hold_v1_object; } 
            struct ::wl_resource *handle;

            struct ::wl_client *client() const { return wl_resource_get_client(handle); }
            int version() const { return wl_resource_get_version(handle); }

            static Resource *fromResource(struct ::wl_resource *resource);
        };

        void init(struct ::wl_client *client, int id, int version);
        void init(struct ::wl_display *display, int version);
        void init(struct ::wl_resource *resource);

        Resource *add(struct ::wl_client *client, int version);
        Resource *add(struct ::wl_client *client, int id, int version);
        Resource *add(struct wl_list *resource_list, struct ::wl_client *client, int id, int version);

        Resource *resource() { return m_resource; }
        const Resource *resource() const { return m_resource; }

        QMultiMap<struct ::wl_client*, Resource*> resourceMap() { return m_resource_map; }
        const QMultiMap<struct ::wl_client*, Resource*> resourceMap() const { return m_resource_map; }

        bool isGlobalRemoved() const { return m_globalRemovedEvent; }
        void globalRemove();

        bool isGlobal() const { return m_global != nullptr; }
        bool isResource() const { return m_resource != nullptr; }

        static const struct ::wl_interface *interface();
        static QByteArray interfaceName() { return interface()->name; }
        static int interfaceVersion() { return interface()->version; }


        void send_begin(uint32_t serial, uint32_t time, struct ::wl_resource *surface, uint32_t fingers);
        void send_begin(struct ::wl_resource *resource, uint32_t serial, uint32_t time, struct ::wl_resource *surface, uint32_t fingers);
        void send_end(uint32_t serial, uint32_t time, int32_t cancelled);
        void send_end(struct ::wl_resource *resource, uint32_t serial, uint32_t time, int32_t cancelled);

    protected:
        virtual Resource *zwp_pointer_gesture_hold_v1_allocate();

        virtual void zwp_pointer_gesture_hold_v1_destroy_global();

        virtual void zwp_pointer_gesture_hold_v1_bind_resource(Resource *resource);
        virtual void zwp_pointer_gesture_hold_v1_destroy_resource(Resource *resource);

        virtual void zwp_pointer_gesture_hold_v1_destroy(Resource *resource);

    private:
        static void bind_func(struct ::wl_client *client, void *data, uint32_t version, uint32_t id);
        static void destroy_func(struct ::wl_resource *client_resource);
        static void display_destroy_func(struct ::wl_listener *listener, void *data);
        static int deferred_destroy_global_func(void *data);

        Resource *bind(struct ::wl_client *client, uint32_t id, int version);
        Resource *bind(struct ::wl_resource *handle);

        static const struct ::zwp_pointer_gesture_hold_v1_interface m_zwp_pointer_gesture_hold_v1_interface;

        static void handle_destroy(
            ::wl_client *client,
            struct wl_resource *resource);

        QMultiMap<struct ::wl_client*, Resource*> m_resource_map;
        Resource *m_resource;
        struct ::wl_global *m_global;
        struct ::wl_display *m_display;
        struct wl_event_source *m_globalRemovedEvent;
        struct DisplayDestroyedListener : ::wl_listener {
            zwp_pointer_gesture_hold_v1 *parent;
        };
        DisplayDestroyedListener m_displayDestroyedListener;
    };
}

QT_WARNING_POP
QT_END_NAMESPACE

#endif
